cwlVersion: v1.2
class: Workflow

requirements:
  ScatterFeatureRequirement: {}
  StepInputExpressionRequirement: {}
  InlineJavascriptRequirement: {}

inputs:
  IndexInput: File[]
  InputReadsMultipleSamples:
    type: 
      type: array
      items: 
        type: array
        items: File
  # numCharsFileName:
  #   type: int
  #   default: 6
  numUnderscoresFileName:
    type: int
    default: 2
  isSingle: boolean
  FragmentLength: double?  
  StandardDeviation: double?
  BootstrapSamples: int?
  resultsFolder: string

steps:
  index:
    run: kallisto-index.cwl
    in:
      InputFiles: IndexInput
      IndexName: 
        source: IndexInput
        valueFrom: $(self[0].nameroot)
    out: [index]
  quant:
    run: kallisto-quant.cwl
    scatter: 
      - InputReads
      - QuantOutfolder
    scatterMethod: dotproduct
    in:
      InputReads: InputReadsMultipleSamples
      # numChars:
      #   source: numCharsFileName
      numUnderscores: numUnderscoresFileName
      QuantOutfolder:
        source: InputReadsMultipleSamples
        # valueFrom: $(self[0].nameroot.substring(0, inputs.numChars))
        valueFrom: $(self[0].nameroot.split('_').slice(0, inputs.numUnderscores).join('_'))
      Index: index/index
      isSingle: isSingle
      FragmentLength: FragmentLength 
      StandardDeviation: StandardDeviation
      BootstrapSamples: BootstrapSamples
    out: [outFolder]
  collectResults:
    run: ./yield-dirInDestination.cwl
    scatter: inDir
    in:
      inDir: quant/outFolder
      destinationDir: resultsFolder
    out: [outDir]

outputs:
  finalOut:
    type: Directory[]
    outputSource: collectResults/outDir
